//*********************************************************************
// Example4Pascal.java
//
// Constructs Pascal's Triangle using the recursive formula for
// binomial coefficients.
//*********************************************************************

class Example4Pascal
{
   public static void main(String[] args)
   {
      final byte NUMBER_OF_ROWS = 15;
      for (int n=0; n < NUMBER_OF_ROWS; n++)
      {
         for (int k=0; k <= n; k++)
            System.out.print(BinomialCoeffs.choose(n, k) + " ");
         System.out.println();
      }
   }//method main
}// class Example4Pascal


class BinomialCoeffs
{
   //=====================================================================
   //  Calculates a binomial coefficient recursively.
   //=====================================================================
   static long choose (int n, int k)
   {
      long coefficient;
      if (k==0 | k==n)
         coefficient = 1;
      else
         coefficient = choose(n - 1, k) + choose(n - 1, k - 1);
      return coefficient;
   }//method choose
}// class BinomialCoeffs
